TITLE An implementation of the WELL512 random number generator
;also includes a procedure to set the state
;and a random range procedure
;brethren 2010
;public domain
INCLUDE \masm32\include\masm32rt.inc

.data
state DWORD 16 DUP(?)	;make sure you initialise the state to random bits
index DWORD 0			;at init you should reset this to 0
sysTime SYSTEMTIME <>

.code
;----------------------------------------------------------
;Returns a 32-bit random number in eax
;----------------------------------------------------------
WELLRNG512 PROC USES ebx ecx edx esi
	LOCAL tmp1:DWORD, tmp2:DWORD, tmp3:DWORD
	mov esi, index
	mov eax, state[esi*4]
	add esi, 13
	and esi, 15
	mov ecx, state[esi*4]
	mov tmp1, eax
	shl tmp1, 16
	mov tmp2, ecx
	shl tmp2, 15
	mov ebx, eax
	xor ebx, ecx
	xor ebx, tmp1
	xor ebx, tmp2
	mov esi, index
	add esi, 9
	and esi, 15
	mov ecx, state[esi*4]
	mov tmp1, ecx
	shr tmp1, 11
	xor ecx, tmp1
	mov esi, index
	mov tmp1, ebx
	xor tmp1, ecx
	mov eax, tmp1
	mov state[esi*4], eax
	shl tmp1, 5
	and tmp1, 0DA442D20h
	xor tmp1, eax
	mov edx, tmp1
	add index, 15
	and index, 15
	mov esi, index
	mov eax, state[esi*4]
	mov tmp1, eax
	shl tmp1, 2
	mov tmp2, ebx
	shl tmp2, 18
	mov tmp3, ecx
	shl tmp3, 28
	xor eax, ebx
	xor eax, edx
	xor eax, tmp1
	xor eax, tmp2
	xor eax, tmp3
	mov state[esi*4], eax

	ret
WELLRNG512 ENDP
;----------------------------------------------------------
;Helper proc used to initialise the 512-bit state used by
;the WELL512 Random number generator
;----------------------------------------------------------
Randomize PROC
	pushad
	mov index, 0
	mov esi, 0
@@:
	INVOKE GetSystemTime, ADDR sysTime
	movzx ebx, sysTime.wMilliseconds
	cmp ebx, 0
	jz @B
	INVOKE GetTickCount
@@:
	mul ebx
	mov state[esi*4], eax
	inc esi
	cmp esi, 16
	jne @B

	popad
	ret
Randomize ENDP
;----------------------------------------------------------
;returns a random number between 0 and n-1 in eax
;----------------------------------------------------------
RandomRange PROC USES edx, n:DWORD
	mov edx, 0
	INVOKE WELLRNG512
	div n
	mov eax, edx

	ret
RandomRange ENDP
END